#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <cstring>

using namespace std;

typedef long long ll;

const int MOD = 1000007;
const int maxn = 10005; 
const int maxk = 1005;

bool can[maxn];
int ans[maxn][maxk][2];
int n, m, k;

int main()
{
	scanf("%d%d%d", &n, &m, &k);
	memset(can, true, sizeof can);
	for (int i = 0; i < m; i++)
	{
		int a;
		scanf("%d", &a);
		can[a] = false;
		can[a - 1] = false;
		can[a + 1] = false;
	}
	memset(ans, 0, sizeof ans);
	ans[1][0][1] = 1;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 0; j <= k; j++)
		{
//			cerr << i << ' ' << j << ' ' << ans[i][j][0] << ' ' << ans[i][j][1] << endl;
			if (can[i] && j < k) ans[i + 1][j + 1][0] = (ans[i + 1][j + 1][0] + ans[i][j][1]) % MOD;
			ans[i + 1][j][1] = (ans[i + 1][j][1] + ans[i][j][1] + ans[i][j][0]) % MOD;
		}
	}
	ll answer = (ans[n + 1][k][0] + ans[n + 1][k][1]) % MOD;
	for (int i = 0; i < k; i++) answer = (answer * (k - i)) % MOD;
	cout << answer << endl;
	return 0;
}

