#include <iostream>
#include <cstdio>
#include <cstring>

using namespace std;

const int maxn = 1005;

char str[maxn];
int kv[20], kvall;

inline bool cand(int c)
{
	return kv[c] <= (kvall + 1) / 2;
}

bool can(int last)
{
	for (int i = 0; i < 10; i++)
	{
		if (i == last && kv[i] > kvall / 2) return false;
		if (i != last && !cand(i)) return false;
	}
	return true;
}

int main()
{
	scanf("%s", str);
	int n = strlen(str);
	memset(kv, 0, sizeof kv);
	for (int i = 0; i < n; i++) kv[str[i] - '0']++;
	kvall = n;
	while (!can(-1))
	{
		for (int i = 0; i < 10; i++) if (!cand(i))
		{
//			cerr << "delete " << i << endl;
			kv[i]--;
			kvall--;
			break;
		}
	}
	int last = -1;
	bool first = true;
	while (kvall > 0)
	{
		for (int i = 9; i >= 0; i--) if (i != last && kv[i] > 0)
		{
			kv[i]--;
			kvall--;
			if (can(i))
			{
				if (!first || i != 0) printf("%d", i);
				first = false;
				last = i;
				break;
			}
			kv[i]++;
			kvall++;
		}
	}
	printf("\n");
	return 0;
}

