#include <cstdio>
#include <ctime>
#include <algorithm>
#include <cstdlib>

using namespace std;

#define LL long long

struct point
{
	int x;
	int y;
};
const int maxn = 75005;
const double inf = 1e18;
point p[maxn];
LL pre_comp[maxn];
int n;

int main()
{
	double starttime = clock() + 3.9 * CLOCKS_PER_SEC;
	int q;
	//freopen("input.txt","r",stdin);
	scanf("%d",&n);
	for (q=1;q<=n;q++)
		scanf("%d%d",&p[q].x,&p[q].y);
	srand(time(0));
	random_shuffle(p+1,p+n+1);
	
	for (int q=1;q<=n;q++)
	{
		pre_comp[q] = (LL)p[q].x * (LL)p[q].x + (LL)p[q].y * (LL)p[q].y;
	}
	double minn = inf;
	double maxx = -inf;
	for (int first=1;first<=n;first++)
	{
		if (clock() > starttime)
			break;
		for (int second=first+1;second<=n;second++) if (p[first].x != p[second].x)
		{
			double nnew = (pre_comp[first]-pre_comp[second]) / (p[first].x-p[second].x);
			if (nnew>maxx)
				maxx=nnew;
			if (nnew<minn)
				minn=nnew;
		}
	}
	maxx /= 2.0;
	minn /= 2.0;
	//printf("%0.8lf %0.8lf\n",minn, maxx);
	printf("%0.8lf\n", maxx-minn);
}

