#include <cstdio>
#include <cstdlib>
#include <cassert>

#define WHITE 0
#define BLACK 1
#define LEFT 0
#define RIGHT 2
#define UP 1
#define DOWN 3

const int maxn = 55;
const int dx[4]={0,-1,0,1};
const int dy[4]={-1,0,1,0};
const char to_out[4]={'L','U','R','D'};
int x,y,n,m;
int color[maxn][maxn];

inline void go(int move)
{
	x+=dx[move];
	y+=dy[move];
	assert(x>0 && x<=n);
	assert(y>0 && y<=m);
	color[x][y]=1-color[x][y];
	printf("%c",to_out[move]);
}

int main()
{
	//freopen("input.txt","r",stdin);
	scanf("%d%d%d%d\n",&n,&m,&x,&y);
	if ((n==1) && (m==1))
		return 0;
	int q,k;
	for (q=1;q<=n;q++)
	{
		for (k=1;k<=m;k++)
		{
			char c1;
			scanf("%c",&c1);
			color[q][k] = (c1=='.' ? WHITE : BLACK);
		}
		scanf("\n");
	}
	if (n!=1)
	{
		while(y!=1)
			go(LEFT);
		if (x==1)
			go(DOWN);
		else
			while(x!=2)
				go(UP);
		for (int str=2;str<=n;str++)
		{
			for (int col=1;col<=m;col++)
			{
				if (color[str-1][col] == BLACK)
				{
					go(UP);
					go(DOWN);
				}
				if (col!=m)
					go(RIGHT);
			}
			for (int col=m;col>1;col--)
				go(LEFT);
			if (str!=n)
				go(DOWN);
		}
	}
	int left=-1;
	for (int poz=1;poz<=m;poz++)
		if (color[n][poz] == BLACK)
		{
			left=poz;
			break;
		}
	while(left!=-1)
	{
		//if (y<left)
			//go(RIGHT);
		if (y<=left)
		{
			//if (y==m)
			//{
			if (y==m)
			{
				if (m==1)
				{
					go(UP);
					go(DOWN);
					go(UP);
				}
				else
				{
					go(LEFT);
					go(RIGHT);
					go(LEFT);
				}
			}
			else go(RIGHT);
		//	}
		}
		else
		{
			for (int i=y;i>left;i--)
				go(LEFT);
			//for (int i=left;i<y;i++)
			//	go(RIGHT);
		}
		left=-1;
		for (int poz=1;poz<=m;poz++)
			if (color[n][poz] == BLACK)
			{
				left=poz;
				break;
			}
	}
	for (int i=1;i<=n;i++)
		for (int j=1;j<=m;j++)
			assert(color[i][j]==WHITE);
}

